/*
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.example.android.vinylfinder;

import android.app.Activity;
import android.support.annotation.Nullable;
import android.os.Bundle;

import android.support.v4.app.Fragment;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.github.clans.fab.FloatingActionButton;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdView;

import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import static java.lang.Math.sqrt;


public class EstatisticasFragment extends Fragment {

    public ProgressBar loadingIndicator;
    public TextView textViewLoadingIndicator;
    static EstatisticasFragment ef;
    static View rootView;
    static Double coeficienteDeVariacaoDosRecordsVerificador;
    static public Menu mOptionsMenu;
    Double maiorPrecoDentroDoCoeficienteDeVariacaoDosRecordsAntesDeRefinar;
    static public FloatingActionButton mFab;
    public static Double menorPrecoDentroDocoeficienteDeVariacaoDosRecords;
    public static Double maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords;

    @Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        // Infla o menu
        inflater.inflate(R.menu.menu_estatisticas, menu);
        super.onCreateOptionsMenu(menu, inflater);
        mOptionsMenu = menu;
    }

    //Método chamado quando o fragment é criado
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        rootView = inflater.inflate(R.layout.fragment_estatisticas, container, false);
        ef = EstatisticasFragment.this;

        //Criação do botão FAB, usado para efetuar cálculo estatístico e remoção de anúncios
        mFab = (FloatingActionButton) rootView.findViewById(R.id.fab);
        mFab.setButtonSize(FloatingActionButton.SIZE_NORMAL);
        mFab.setColorNormal(ContextCompat.getColor(getActivity(), R.color.colorMaterialPrimaryDark));
        mFab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            //Inicialização de Variáveis
            maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords = 0.0;
            maiorPrecoDentroDoCoeficienteDeVariacaoDosRecordsAntesDeRefinar = 0.0;

            //Percorre todos os Records e seleciona o de maior preço
            for (int j = 0; j < ResultadosFragment.recordsGlobal.size(); j++){
                if (ResultadosFragment.recordsGlobal.get(j).getmPrice() > maiorPrecoDentroDoCoeficienteDeVariacaoDosRecordsAntesDeRefinar){
                    maiorPrecoDentroDoCoeficienteDeVariacaoDosRecordsAntesDeRefinar = ResultadosFragment.recordsGlobal.get(j).getmPrice();
                }
            }
                System.out.println(maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords);
                System.out.println("Antes de Refinar" + maiorPrecoDentroDoCoeficienteDeVariacaoDosRecordsAntesDeRefinar);

                while(maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords != maiorPrecoDentroDoCoeficienteDeVariacaoDosRecordsAntesDeRefinar){
                    maiorPrecoDentroDoCoeficienteDeVariacaoDosRecordsAntesDeRefinar = maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords;

                    //Estatística propriamente dita, começa aqui
                    refinarAteCoeficienteQuinze();

                    if (maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords != maiorPrecoDentroDoCoeficienteDeVariacaoDosRecordsAntesDeRefinar) {
                        for (int i = 0; i < ResultadosFragment.recordsGlobal.size(); i++) {
                            if (ResultadosFragment.recordsGlobal.get(i).getmPrice() > maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords) {
                                //System.out.println(">>> Entrei no IF de preço maior oque o estipulado pelo coeficiente de variação");
                                Record recordSendoProcessadoNoMomento = ResultadosFragment.rf.mAdapter.getItem(i);

                                //Move o registro para a Lixeira
                                adicionarRecordEmDeletadosFragment(i, recordSendoProcessadoNoMomento);

                                //Remove o registro da aba de Resultados
                                removerRecordDeResultadosFragment(i, recordSendoProcessadoNoMomento);

                                //Atualiza a aba de Estatísticas com a média
                                configurarTextViewMediaFinal(realizarSomaDosPrecos());
                                //configurarTextViewSomaDosRecordsDesvioPadraoECoeficienteDeVariacao(realizarSomaDosPrecos());
                                i--;
                            }
                        }
                    }
                }
            }
        });

        mFab.setVisibility(View.GONE);

        // Esconder teclado, loading indicator e textView porque os dados foram carregados
        esconderTeclado(getActivity());
        esconderLoadingIndicator();
        esconderTextViewDeAndamentoDoLoadingIndicator();
        
        //FragmentActivity activity = (FragmentActivity) rootView.getContext();
        return rootView;
    }

    private void esconderTextViewDeAndamentoDoLoadingIndicator() {
        textViewLoadingIndicator = (TextView) rootView.findViewById(R.id.textView_loading_indicator);
        textViewLoadingIndicator.setVisibility(View.GONE);
    }

    private void esconderLoadingIndicator() {
        loadingIndicator = (ProgressBar) rootView.findViewById(R.id.loading_indicator);
        loadingIndicator.setVisibility(View.GONE);
    }


    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setHasOptionsMenu(true);
        setRetainInstance(true);
    }

    public static Double fazerMedia(Double priceSum, int sumOfRecords) {

        Double priceMedia = 0.0;

        if (sumOfRecords > 0) {
            priceMedia = (priceSum / sumOfRecords);
        }
        System.out.println(priceMedia);
        return priceMedia;
    }

    static public Double calcularcoeficienteDeVariacaoDosRecords(Double priceMedia, Double desvioPadrao) {
        Double coeficienteDeVariacaoDosRecords;
        coeficienteDeVariacaoDosRecords = (desvioPadrao / priceMedia) * 100;
        System.out.println("CV: " + coeficienteDeVariacaoDosRecords);
        return coeficienteDeVariacaoDosRecords;
    }

    //Calculo do coeficiente de variação
    static public void refinarAteCoeficienteQuinze() {
        List<Record> recordsParaRefinar = new ArrayList<Record>(ResultadosFragment.recordsGlobal);
        Double somaDosPrecos = calcularSomaDosPrecos(recordsParaRefinar);
        Double mediaDosRecords = fazerMedia(somaDosPrecos, recordsParaRefinar.size());
        Double desvioPadraoDosRecords = calcularDesvioPadrao(mediaDosRecords, recordsParaRefinar);
        Double coeficienteDeVariacaoDosRecords = calcularcoeficienteDeVariacaoDosRecords(mediaDosRecords, desvioPadraoDosRecords);

        while (coeficienteDeVariacaoDosRecords > 15) {

            for (int i = 0; i < recordsParaRefinar.size(); i++) {
                if ((recordsParaRefinar.get(i).getmPrice() > (mediaDosRecords + desvioPadraoDosRecords)) || (recordsParaRefinar.get(i).getmPrice() < (mediaDosRecords - desvioPadraoDosRecords))) {
                    somaDosPrecos = somaDosPrecos - recordsParaRefinar.get(i).getmPrice();
                    recordsParaRefinar.remove(i);
                }
            }

            mediaDosRecords = fazerMedia(somaDosPrecos, recordsParaRefinar.size());
            desvioPadraoDosRecords = calcularDesvioPadrao(mediaDosRecords, recordsParaRefinar);
            coeficienteDeVariacaoDosRecords = calcularcoeficienteDeVariacaoDosRecords(mediaDosRecords, desvioPadraoDosRecords);
            if (coeficienteDeVariacaoDosRecords.equals(coeficienteDeVariacaoDosRecordsVerificador)){
                break;
            } else {
                coeficienteDeVariacaoDosRecordsVerificador = coeficienteDeVariacaoDosRecords;
            }
            calcularExtremosDentroDoCoeficienteDeVariacaoDosRecords(recordsParaRefinar);

        }

    }

    static public void calcularExtremosDentroDoCoeficienteDeVariacaoDosRecords(List<Record> recordsParaRefinar) {
        menorPrecoDentroDocoeficienteDeVariacaoDosRecords = recordsParaRefinar.get(0).getmPrice();
        maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords = 0.0;
        for (int i = 0; i < recordsParaRefinar.size(); i++) {
            Double preco = recordsParaRefinar.get(i).getmPrice();
            if (preco > maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords) {
                maiorPrecoDentroDoCoeficienteDeVariacaoDosRecords = preco;
            }

            if (preco < menorPrecoDentroDocoeficienteDeVariacaoDosRecords) {
                menorPrecoDentroDocoeficienteDeVariacaoDosRecords = preco;
            }
        }
    }

    static public Double calcularSomaDosPrecos(List<Record> recordsParaRefinar) {
        Double somaDosPrecos = 0.0;
        for (int j = 0; j < recordsParaRefinar.size(); j++) {
            somaDosPrecos += recordsParaRefinar.get(j).getmPrice();
        }
        return somaDosPrecos;
    }

    static public Double calcularDesvioPadrao(Double mediaDosPrecos, List<Record> records) {
        System.out.println("mediaDosPrecos: " + mediaDosPrecos);

        Double varianciaDosPrecos = calcularVariancia(records, mediaDosPrecos);
        Double desvioPadrao;

        System.out.println("priceAcumulator: " + varianciaDosPrecos);
        System.out.println("sumOfRecords: " + records.size());
        desvioPadrao = sqrt(varianciaDosPrecos / (records.size() - 1));
        System.out.println("Desvio Padrão: " + desvioPadrao);
        return desvioPadrao;
    }

    static public Double calcularVariancia(List<Record> records, Double mediaDosPrecos) {
        Double preco;
        Double precoMenosMedia;
        Double varianciaDosPrecos = 0.0;
        for (int i = 0; i < records.size(); i++) {
            preco = records.get(i).getmPrice();
            precoMenosMedia = preco - mediaDosPrecos;
            varianciaDosPrecos = varianciaDosPrecos + ((precoMenosMedia) * (precoMenosMedia));
        }
        return varianciaDosPrecos;
    }

    public static void esconderTeclado(Activity activity) {
        View focusedView = activity.getCurrentFocus();
        if (focusedView != null) {
            InputMethodManager inputMethodManager =
                    (InputMethodManager) activity.getSystemService(
                            Activity.INPUT_METHOD_SERVICE);
            inputMethodManager.hideSoftInputFromWindow(
                    activity.getCurrentFocus().getWindowToken(), 0);
        }
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        if (item.isChecked())
            item.setChecked(false);
        else
            item.setChecked(true);


        switch (item.getItemId()) {
            case R.id.menuInserirCep:
                MainActivity.mn.dialogCEP();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }

    }

    private Double realizarSomaDosPrecos() {
        Double somaDosPrecos = 0.0;
        for (int j = 0; j < ResultadosFragment.recordsGlobal.size(); j++) {
            somaDosPrecos += ResultadosFragment.recordsGlobal.get(j).getmPrice();
            System.out.println("getmPrice(): " + ResultadosFragment.recordsGlobal.get(j).getmPrice());
        }
        return somaDosPrecos;
    }

    private void removerRecordDeResultadosFragment(int i, Record recordSendoProcessadoNoMomento) {
        ResultadosFragment.recordsGlobal.remove(i);
        ResultadosFragment.rf.mAdapter.remove(recordSendoProcessadoNoMomento);
    }

    private void adicionarRecordEmDeletadosFragment(int i, Record recordSendoProcessadoNoMomento) {
        DeletadosFragment.recordsDeletadosGlobal.add(ResultadosFragment.rf.recordsGlobal.get(i));
        DeletadosFragment.df.mDeletadosAdapter.add(recordSendoProcessadoNoMomento);
    }

    private void configurarTextViewMediaFinal(Double somaDosPrecos) {
        Double mediaFinalEmDouble = calcularMediaFinalERetornarEmDouble(somaDosPrecos);
        TextView mediaFinal = (TextView) EstatisticasFragment.rootView.findViewById(R.id.textViewMedia);
        configurarTextoDaTextViewMediaFinal(mediaFinalEmDouble, mediaFinal);
        mediaFinal.setVisibility(View.VISIBLE);
    }

    private void configurarTextoDaTextViewMediaFinal(Double mediaFinalEmDouble, TextView mediaFinal) {
        //mediaFinalEmString = QueryUtils.trimPrice(mediaFinalEmString);
        Activity activity = (Activity) EstatisticasFragment.rootView.getContext();
        mediaFinal.setText(converterDoubleEmReais(mediaFinalEmDouble));
        mediaFinal.setTextSize(50);

        mediaFinal.setTextColor(ContextCompat.getColor(activity, R.color.colorPrice));
    }

    public String converterDoubleEmReais(Double d) {
        Locale ptBr = new Locale("pt", "BR");
        return NumberFormat.getCurrencyInstance(ptBr).format(d);
    }


    private Double calcularMediaFinalERetornarEmDouble(Double somaDosPrecos) {
        return calcularMediaEmDouble(somaDosPrecos);
    }

    private Double calcularMediaEmDouble(Double somaDosPrecos) {
        return EstatisticasFragment.fazerMedia(somaDosPrecos, ResultadosFragment.recordsGlobal.size());
    }
}
