package com.example.android.vinylfinder;

import java.util.Date;

public class Record implements Comparable<Record> {

    //Override em método compareTo para ordenar os discos por ordem de data em que o anúncio foi postado
    @Override
    public int compareTo(Record another) {
        if (getmAnuncioDate() == null || another.getmAnuncioDate() == null)
            return 0;
        return another.getmAnuncioDate().compareTo(getmAnuncioDate());
    }

    //Variáveis
    private String mUrlPictureBig;
    private String mName;
    private String mThumbnailUrl;
    private String mPermalink;
    private String mSellerLocation;
    private String mSellerReputation;
    private String mShippingMode;
    private Double mPrice;
    private Double mLatitude;
    private Double mLongitude;
    private Double mPrecoSedex;
    private Double mPrecoPac;
    private Double mMercadoEnviosNormal;
    private Double mMercadoEnviosExpresso;
    private Double mMercadoLivreCustomPrice;
    private Double mPrecoPacOuNormalouTabelado;
    private Double mPrecoSedexOuExpresso;
    private Date mAnuncioDate;
    private Float distanceSellerBuyer;
    private String mUrlPictureBigSize;
    private boolean mFreeShipping;

    //Construtor
    public Record(String mName, Double mPrice, String mThumbnailUrl, String mPermalink, String mSellerLocation, Double mLatitude, Double mLongitude, boolean mFreeShipping, String mSellerReputation, Date mAnuncioDate, Double mPrecoSedex, Double mPrecoPac, String mShippingMode, Double mMercadoEnviosNormal, Double mMercadoEnviosExpresso, Double mMercadoLivreCustomPrice, String mUrlPictureBig, String mUrlPictureBigSize) {
        this.mName = mName;
        this.mPrice = mPrice;
        this.mThumbnailUrl = mThumbnailUrl;
        this.mPermalink = mPermalink;
        this.mLatitude = mLatitude;
        this.mLongitude = mLongitude;
        this.mFreeShipping = mFreeShipping;
        this.mSellerLocation = mSellerLocation;
        this.mSellerReputation = mSellerReputation;
        this.mAnuncioDate = mAnuncioDate;
        this.mPrecoSedex = mPrecoSedex;
        this.mPrecoPac = mPrecoPac;
        this.mShippingMode = mShippingMode;
        this.mMercadoEnviosNormal = mMercadoEnviosNormal;
        this.mMercadoEnviosExpresso = mMercadoEnviosExpresso;
        this.mMercadoLivreCustomPrice = mMercadoLivreCustomPrice;
        this.mUrlPictureBig = mUrlPictureBig;
        this.mUrlPictureBigSize = mUrlPictureBigSize;

        //Verifica quais tipos de frete o vendedor selecionou para o disco em questão
        //e popula a(s) variavel(is) de preço, de acordo
        if (mShippingMode.equals("me1") || mShippingMode.equals("me2")){
            if(mMercadoEnviosExpresso != null && mMercadoEnviosExpresso > 0) {
                this.mPrecoSedexOuExpresso = mMercadoEnviosExpresso + mPrice;
            }
            else {
                this.mPrecoSedexOuExpresso = 0.0;
            }
            if(mMercadoEnviosNormal != null && mMercadoEnviosNormal > 0) {
                this.mPrecoPacOuNormalouTabelado = mMercadoEnviosNormal + mPrice;
            }
            else {
                this.mPrecoPacOuNormalouTabelado = 0.0;
            }
        } else if (mShippingMode.equals("custom")){
            this.mPrecoPacOuNormalouTabelado = mMercadoLivreCustomPrice + mPrice;
            this.mPrecoSedexOuExpresso = mMercadoLivreCustomPrice + mPrice;
        } else if (mShippingMode.equals("not_specified")){
            this.mPrecoPacOuNormalouTabelado = mPrecoPac + mPrice;
            this.mPrecoSedexOuExpresso = mPrecoSedex + mPrice;
        }

    }

    //Getters e Setters
    public String getmName() {
        return mName;
    }

    public Double getmPrice() {
        return mPrice;
    }

    public String getmThumbnailUrl() {
        return mThumbnailUrl;
    }

    public String getmPermalink() {
        return mPermalink;
    }

    public String getmSellerLocation() {
        return mSellerLocation;
    }

    public String getmSellerReputation() {
        return mSellerReputation;
    }

    public Date getmAnuncioDate() {
        return mAnuncioDate;
    }

    public Double getmLatitude() {
        return mLatitude;
    }

    public Double getmLongitude() {
        return mLongitude;
    }

    public Float getDistanceSellerBuyer() {
        return distanceSellerBuyer;
    }

    public void setDistanceSellerBuyer(Float distanceSellerBuyer) {
        this.distanceSellerBuyer = distanceSellerBuyer;
    }

    public boolean ismFreeShipping() {
        return mFreeShipping;
    }

    public Double getmPrecoSedex() {
        return mPrecoSedex;
    }

    public Double getmPrecoPac() {
        return mPrecoPac;
    }

    public Double getmPrecoMaisSedex() {return (getmPrice() + getmPrecoSedex());}

    public Double getmPrecoMaisPac() {return (getmPrice() + getmPrecoPac());}

    public String getmShippingMode() {
        return mShippingMode;
    }

    public Double getmMercadoEnviosNormal() {
        return mMercadoEnviosNormal;
    }

    public Double getmMercadoEnviosExpresso() {
        return mMercadoEnviosExpresso;
    }

    public Double getmMercadoLivreCustomPrice() {
        return mMercadoLivreCustomPrice;
    }

    public Double getmPrecoPacOuNormalouTabelado() {
        return mPrecoPacOuNormalouTabelado;
    }

    public Double getmPrecoSedexOuExpresso() {
        return mPrecoSedexOuExpresso;
    }

    public String getmUrlPictureBig() {
        return mUrlPictureBig;
    }

    public String getmUrlPictureBigSize() {
        return mUrlPictureBigSize;
    }
}

