package com.example.android.vinylfinder;


import android.content.Context;

import java.util.List;

/**
 * Carrega uma lista de discos usando uma AsyncTask para executar
 * uma requisição para a URL passada.
 */
public class RecordLoader extends android.support.v4.content.AsyncTaskLoader<List<Record>> {

    //URL para realizar a pesquisa
    private String mUrl;

    //List principal de Records
    List<Record> records;

    //Construtor recebendo o contexto e a URL passados pela MainActivity
    public RecordLoader(Context context, String url) {
        super(context);
        mUrl = url;
    }

    @Override
    protected void onStartLoading() {
        if (!MainActivity.isRunning)
            forceLoad();
    }

    //Faz o carregamento, em background, dos Records, chamando métodos da QueryUtils
    @Override
    public List<Record> loadInBackground() {
        if (mUrl == null) {
            return null;
        }

        // Realiza a conexão de rede, faz parse do resultado, e extrai a lista de Records.
        records = QueryUtils.fetchRecordData(mUrl.toString());
        return records;
    }




}
