package com.example.android.vinylfinder;

import android.content.Context;
import android.widget.Toast;

import com.google.android.gms.ads.AdListener;
import com.google.android.gms.ads.AdRequest;

/**
 * Created by marcelofb on 23/04/17.
 */

public class ToastAdListener extends AdListener {
    private Context mContext;
    private String mErrorReason;

    public ToastAdListener(Context context) {
        super();
        this.mContext = context;
    }

    @Override
    public void onAdLoaded() {
        super.onAdLoaded();
        Toast.makeText(mContext, "OnAdLoaded()", Toast.LENGTH_LONG).show();
    }

    @Override
    public void onAdOpened() {
        super.onAdOpened();
        Toast.makeText(mContext, "onAdOpened()", Toast.LENGTH_LONG).show();
    }

    @Override
    public void onAdLeftApplication() {
        super.onAdLeftApplication();
        Toast.makeText(mContext, "onAdLeftApplication()", Toast.LENGTH_LONG).show();
    }

    @Override
    public void onAdFailedToLoad(int errorCode) {
        super.onAdFailedToLoad(errorCode);
        mErrorReason = "";
        switch (errorCode){
            case AdRequest.ERROR_CODE_INTERNAL_ERROR:
                mErrorReason = "Internal Error";
                break;
            case AdRequest.ERROR_CODE_INVALID_REQUEST:
                mErrorReason = "Invalid Request";
                break;
            case AdRequest.ERROR_CODE_NETWORK_ERROR:
                mErrorReason = "Network Error";
                break;
            case AdRequest.ERROR_CODE_NO_FILL:
                mErrorReason = "No Fill Error";
                break;
        }
        Toast.makeText(mContext, String.format("onAdFailedToLoad(%s)", mErrorReason ), Toast.LENGTH_LONG).show();
    }

    @Override
    public void onAdClosed() {
        super.onAdClosed();
        Toast.makeText(mContext, "onAdClosed()", Toast.LENGTH_LONG).show();
    }

    public String getmErrorReason() {
        return mErrorReason;
    }
}
